﻿require 'map'
require 'output'
require 'names'
--[[------------------------------------------------------------------------------------------------
LOVE LOAD search keyword: alpha
------------------------------------------------------------------------------------------------]]

function love.load()
	
	loadMap('mapstring.lua')

	width = love.graphics.getWidth() --width of window
	height = love.graphics.getHeight() --height of window


	--[[player = {
        --grid_x = 256,
        --grid_y = 256,
        --grid_x = width/2,
	--grid_y = height/2,
	grid_x = 32,
	grid_y = 32,
	image = love.graphics.newImage("hero2.png")
   	}]]

	creditstext = {y=0,speed=100}

	--[[cloud = {

	cloud1 = {image = love.graphics.newImage("cloud2.png"), width = love.graphics.getWidth(image), x = 0,y = 20, speed = 70},
	cloud2 = {image = love.graphics.newImage("cloud5.png"), width = love.graphics.getWidth(image), x = 0, y = 100, speed = 50},
	cloud3 = {image = love.graphics.newImage("cloud5.png"), width = love.graphics.getWidth(image), x = 0, y= 200, speed = 100},
	cloud4 = {image = love.graphics.newImage("cloud2.png"), width = love.graphics.getWidth(image), x = 0, y= 400, speed = 20}
}]]

	--cloud = {}

	--[[ WRONG
	cloud[1] = {image = love.graphics.newImage("cloud2.png"), width = love.graphics.getWidth(image), x=0, y=20, speed=70}
	cloud[2] = {image = love.graphics.newImage("cloud5.png"), width = love.graphics.getWidth(image), x=0, y=20, speed=50}
	cloud[3] = {image = love.graphics.newImage("cloud5.png"), width = love.graphics.getWidth(image), x=0, y=20, speed=100}
	cloud[4] = {image = love.graphics.newImage("cloud2.png"), width = love.graphics.getWidth(image), x=0, y=20, speed=20}]]



	introfont = love.graphics.newFont("yoster.ttf",90)
	love.graphics.setFont(introfont)

    	state = "game"

	namegeneration()
	--test = Player.create(500,180)


	playertest = {}
	playertest.x = 500
	playertest.y = 180
	playertest.name = string.upper(firstname).." "..string.upper(lastname)
	playertest.hp = 100
	playertest.dungeonlevel = 1

	tilesheet = love.graphics.newImage( "Alloy_curses_12x12.png" )

	local tileW, tileH = 12,12
	local tilesetW, tilesetH = tilesheet:getWidth(), tilesheet:getHeight()

	playerquad = love.graphics.newQuad(0,  48, tileW, tileH, tilesetW, tilesetH)


		playertilex = 27
	playertiley = 14


end

--[[------------------------------------------------------------------------------------------------
LOVE DRAW search keyword: beta
------------------------------------------------------------------------------------------------]]
function love.draw()

	if state == "game" then
		output.game()
		--camera:set(player.grid_x,player.grid_y)
	    	--game()
		--output.game()
		--camera:unset()
		--namegeneration()
		output.stats()
		--love.graphics.print(playertest.name,200,200)
		love.graphics.draw(tilesheet, playerquad, playertest.x, playertest.y)
		--drawplayer()
		
		--test:draw(x,y)
		--mapcheck()
		--
		loadMap('mapstring.lua')

		playercheck(dx,dy)

		--test:coordinate(x,y)

    	elseif state == "menu" then
		--creditstext.y = 0
		--output.intro()
		--output.mainmenumouse()
		--output.intro_movement()
		--output.selectsong()
		--output.sound()
		state = 'game'
		--output.mainmenu()
	elseif state == "credits" then
		output.credits()
	elseif state == "story" then
		output.story()
    	end

    --drawMap()
    --love.graphics.draw(player.image,player.grid_x,player.grid_y)
    --love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)

end
-----------------------------------------------------------------------------------------------




--[[------------------------------------------------------------------------------------------------
LOVE UPDATE search keyword: gamma
------------------------------------------------------------------------------------------------]]

function love.update(dt)

	if state == "game" then
        	--output.game()
		
    	elseif state == "menu" then
		output.intro_movement(dt)
	elseif state == "credits" then
		output.credits_movement(dt)
	elseif state == "story" then
		output.credits_movement(dt)
	end

end

------------------------------------------------------------------------------------------------
--[[local src
function sound()
    if not src or src:isStopped() then
        love.audio.stop()
        love.audio.setVolume(0.5)
        src = love.audio.newSource("soundtrack.mp3")
        src:play()
    end
end]]
--[[
function menu()

	love.graphics.setFont(introfont)
	love.graphics.setColor(0,0,0)
	love.graphics.printf("example header",0,height/7,800,"center") --CHANGE
	love.graphics.setFont(menufont)
	love.graphics.printf("Play /enter/", 0,200,width,"center")
	love.graphics.printf("Story /s/", 0,300,width,"center")
	love.graphics.printf("Credits /c/", 0,400,width,"center")
	love.graphics.printf("Quit /q/", 0,500,width,"center")

end]]

--[[function boot()
    sound()    
    intro()
    menu()
end]]

function story() --WORK AT THIS
	love.graphics.clear( )
	love.graphics.print("this works durr durr",300,300)
end



--[[function intro()


    love.graphics.setColor(223,243,199)
    love.graphics.rectangle("fill",0,0,width,height)
    love.graphics.setColor(255,255,255)
    love.graphics.draw(moon.moon,moon.x,moon.y)
    --[[love.graphics.draw(cloud.cloud1.image, cloud.cloud1.x-300, cloud.cloud1.y)
    love.graphics.draw(cloud.cloud2.image, cloud.cloud2.x-300, cloud.cloud2.y)
    love.graphics.draw(cloud.cloud3.image, cloud.cloud3.x-225, cloud.cloud3.y)
    love.graphics.draw(cloud.cloud4.image, cloud.cloud4.x-225, cloud.cloud4.y)

    for i=1,#cloud do
	love.graphics.draw(cloud[i].image,cloud[i].x- cloud[i].width, cloud[i].y)
    end


end ]]

--[[function intromovement(dt) -- MOVEMENT IN INTRO

	--MOON MOVEMENT

	if moon.x > width then
		moon.x = 0 - moon.width
	end

	if moon.x < ((width/2) - (moon.width/2)) then
		moon.x = moon.x + (moon.speed.x * dt)
		moon.y = moon.y - (moon.speed.y * dt)
	elseif moon.x > ((width/2) - (moon.width/2)) then
		moon.x = moon.x + (moon.speed.x * dt)
		moon.y = moon.y + (moon.speed.y * dt)
	end

	--CLOUD MOVEMENT

--[[	cloud.cloud1.x = cloud.cloud1.x + cloud.cloud1.speed*dt 
	if cloud.cloud1.x > width + cloud.cloud1.width then --CHECK AND EDIT
		cloud.cloud1.x = 0
	end

	cloud.cloud2.x = cloud.cloud2.x + cloud.cloud2.speed*dt
	if cloud.cloud2.x > 1100 then --CHANGE
		cloud.cloud2.x = 0
	end

	cloud.cloud3.x = cloud.cloud3.x + cloud.cloud3.speed*dt
	if cloud.cloud3.x > 1100 then --CHANGE
		cloud.cloud3.x = 0
	end

	cloud.cloud4.x = cloud.cloud4.x + cloud.cloud4.speed*dt
	if cloud.cloud4.x > 1100 then --CHANGE
		cloud.cloud4.x = 0
	end

	for i=1,#cloud do
		cloud[i].x = cloud[i].x + cloud[i].speed*dt 
			if cloud[i].x > width + cloud[i].width then --CHECK AND EDIT
				cloud[i].x = 0
			end
	end


end]]




--[[------------------------------------------------------------------------------------------------
LOVE KEYPRESSED search keyword: delta
------------------------------------------------------------------------------------------------]]
--
--


function love.keypressed(key) --MOVEMENT FOR PLAYER ON GRID

	if state == "game" then	

		local tile = 12

		if key == "up" then

			if playercheck(0,-1) then

				playertest.y = playertest.y - tile
				playertiley = playertiley - 1
			
			end


			--if mapcheck(0,-1) then


			
			--end

			--if mapcheck(0,-1) then
    			--if testMap(0,-1) then
        		--player.grid_y = player.grid_y - 32
			--camera:move(0,-32)
					--test:move(0,-1)
			--end
  			--end
 		elseif key == "down" then

			playertest.y = playertest.y + tile
    			--if testMap(0,1) then
        		--player.grid_y = player.grid_y + 32
			--test:move(0,1)
			--camera:setPosition(0, player.grid_y - 322)
        		--end
    		elseif key == "left" then

			playertest.x = playertest.x - tile
    			--if testMap(-1,0) then
            		--player.grid_x = player.grid_x - 32
	    		--camera:setPosition(player.grid_x - 32,0)
        		--end
			--test:move(-1,0)
    		elseif key == "right" then

			playertest.x = playertest.x + tile
    			--if testMap(1,0) then
        		--player.grid_x = player.grid_x + 32
			--test:move(1,0)
			--camera:setPosition(player.grid_x + 32,0)
        		--end
		end

	elseif state == "menu" then

    		if key == "return" then
    			state = "game"
   		elseif key == "c" then
    			state = "credits"   	
    		elseif key == "q" then
    			love.event.quit()   	
    		elseif key == "s" then
    			state = "story" 	
    		end
	end

end

--[[function testMap(x,y)
	local rowIndex,columnIndex = 1,1
  	for row in tileString:gmatch("[^\n]+") do
       	columnIndex = 1
    	for character in row:gmatch(".") do
    		tileTable[columnIndex][rowIndex] = character
    		columnIndex = columnIndex + 1
    	end
    	rowIndex=rowIndex+1
  	end
	if tileTable[(player.grid_x/32) + x][(player.grid_y/32) + y] == '|' then
		return false
	end
	return true
end]]
